Grist integration: operations for AI agents
Grist connects to Type.com as an integration. This page lists the 116 operations documented for Claude and Codex in Type.com: 44 read, 53 write, 19 destructive.
About Grist
Grist is a relational spreadsheet platform that combines the flexibility of a spreadsheet with the robustness of a database, allowing users to create custom applications tailored to their data needs.
Categories: Productivity & Project Management
How to connect Grist to Type.com
- Access
- Organization connection: one shared account for the workspace.
To add the connection, follow the steps in Space connections.
Documented operations
116 operations. Your connection's permissions determine which operations are available. API references describe the vendor surface; they do not expand your connection's credentials or access.
116 operations listed.
Orgs
- Read
List the orgs you have access to
This enumerates all the team sites or personal areas available.
- Read
Describe an org
GET /orgs/{orgId}
- Read
List users with access to org
GET /orgs/{orgId}/access
- Read
Get organization usage summary
Get usage statistics for all non-deleted documents in the organization. Only accessible to organization owners.
- Write
Modify an org
PATCH /orgs/{orgId}
- Write
Change who has access to org
PATCH /orgs/{orgId}/access
- Destructive
Delete an org
DELETE /orgs/{orgId}/{name}
Workspaces
- Read
List workspaces and documents within an org
GET /orgs/{orgId}/workspaces
- Read
Describe a workspace
GET /workspaces/{workspaceId}
- Read
List users with access to workspace
GET /workspaces/{workspaceId}/access
- Write
Create an empty workspace
POST /orgs/{orgId}/workspaces
- Write
Modify a workspace
PATCH /workspaces/{workspaceId}
- Write
Restore workspace from trash
Recover a workspace that was previously soft-deleted. Only works if the workspace is still in the trash.
- Write
Change who has access to workspace
PATCH /workspaces/{workspaceId}/access
- Destructive
Delete a workspace
DELETE /workspaces/{workspaceId}
- Destructive
Move workspace to trash
Soft-delete the workspace by moving it to trash. The workspace can be restored using the unremove endpoint. If the permanent query parameter is set to true, the workspace is permanently deleted instead.
Docs
- Read
Describe a document
GET /docs/{docId}
- Read
List users with access to document
GET /docs/{docId}/access
- Read
Get users for 'View As' feature
Get users that can be used with the "View As" feature for testing access rules. Only document owners can call this endpoint. Users are drawn from: - Users the document is shared with - Users mentioned in user attribute tables - Predefined example users
- Read
Content of document, as an Sqlite file
GET /docs/{docId}/download
- Read
Content of document, as an Excel file
GET /docs/{docId}/download/xlsx
- Read
Content of table, as a CSV file
GET /docs/{docId}/download/csv
- Read
Content of table, as a TSV file
Download table data as tab-separated values.
- Read
Content of table, as a DSV file
Download table data using a custom delimiter (💩).
- Read
The schema of a table
The schema follows frictionlessdata's table-schema standard.
- Read
List document snapshots
Returns a list of snapshots (backups) of the document. Snapshots are created automatically as the document is edited. Most recent snapshots are listed first.
- Read
Get document action history states
Returns a list of document states representing the action history. Each state has a sequential number (n) and a hash (h) that uniquely identifies that point in history. Most recent state is first.
- Read
Compare document versions
Compare two versions of the same document by their state hashes. Returns details about what changed between the versions.
- Read
Compare two documents
Compare this document with another document. Useful for comparing a fork with its trunk document.
- Read
List change proposals
List proposals associated with a document. Proposals are suggested changes from forks that can be reviewed and applied to the trunk document.
- Read
Get formula timing status
Check if formula timing is enabled for a document and retrieve timing data if available. Only document owners can access timing information.
- Write
Create an empty document
POST /workspaces/{workspaceId}/docs
- Write
Import an existing document
POST /workspaces/{workspaceId}/import
- Write
Create a document
A unified endpoint for creating documents. Can create an empty document, copy an existing document, or import a file.
- Write
Modify document metadata (but not its contents)
PATCH /docs/{docId}
- Write
Restore document from trash
Recover a document that was previously soft-deleted. Only works if the document is still in the trash.
- Write
Move document to another workspace.
PATCH /docs/{docId}/move
- Write
Pin a document
Pin the document so it appears in a prominent location. Pinned documents are displayed at the top of workspace listings for easy access.
- Write
Unpin a document
Remove the pinned status from a document.
- Write
Disable a document.
Disabled documents cannot be accessed or modified. Moving and renaming a disabled doc is also forbidden, as well as accessing or submitting published forms associated to a disabled document. Disabled documents, however, can be moved to and restored from the trash.
- Write
Enable a document.
If a document has been previously disabled, this will restore all former access to a document, including access to its associated published forms. Only admin accounts can enable a document.
- Write
Copies a document to a workspace.
POST /docs/{docId}/copy
- Write
Fork a document
Create a fork of a document. A fork is a personal copy that tracks its relationship to the original document. Forks can be used to experiment with changes before applying them to the original.
- Write
Change who has access to document
PATCH /docs/{docId}/access
- Write
Create a change proposal
Create a proposal from a fork to its trunk document. The proposal contains the comparison of changes between the fork and trunk. This endpoint can only be called on a fork document.
- Write
Apply a change proposal
Apply a proposal's changes to the document. This merges the fork's changes into the trunk document.
- Write
Reload a document
Closes and reopens the document, forcing the python engine to restart.
- Write
Flush document to storage
Ensure all pending changes to the document are written to persistent storage. Returns true if the document was flushed, false if the document was not open.
- Write
Reassign document to appropriate worker
Administrative endpoint that checks if a document is assigned to the expected worker group and frees it for reassignment if not. Used for load balancing and maintenance operations.
- Write
Replace document content
Replace the current document content with content from another source. Can restore from a snapshot or copy from another document.
- Write
Set recovery mode for a document
Controls the recovery mode of a document. Recovery mode helps in recovering from errors or corrupted states. Only document owners can control recovery mode.
- Write
Start formula timing
Start collecting timing information for formula calculations. Only document owners can start timing.
- Write
Stop formula timing
Stop collecting timing information and return the collected data. Only document owners can stop timing.
- Write
Apply a list of user actions
Apply a sequence of user actions to a document. This is a low-level endpoint for making batch changes using Grist's internal action format. Each action is an array where the first element is the action type.
- Destructive
Delete a document
DELETE /docs/{docId}
- Destructive
Move document to trash
Soft-delete the document by moving it to trash. The document can be restored using the unremove endpoint. If the permanent query parameter is set to true, the document is permanently deleted instead.
- Destructive
Remove document snapshots
Remove specific snapshots from a document's backup history. Only document owners can remove snapshots.
- Destructive
Truncate the document's action history
POST /docs/{docId}/states/remove
POST /docs/{docId}/states/remove
Templates
- Read
List available templates
Get all available templates. Templates are organized by workspace within a template organization configured on the server. Note: Requires a template organization to be configured on the server.
- Read
Get template details
Get information about a specific template. Note: Requires a template organization to be configured on the server.
Widgets
- Read
List available custom widgets
Get all widget definitions from the configured widget repository. Custom widgets extend Grist's functionality with specialized views.
Attachments
- Read
List metadata of all attachments in a doc
GET /docs/{docId}/attachments
- Read
Get the metadata for an attachment
GET /docs/{docId}/attachments/{attachmentId}
- Read
Download the contents of an attachment
GET /docs/{docId}/attachments/{attachmentId}/download
- Read
Download all attachments
GET /docs/{docId}/attachments/archive
- Read
Get external store
GET /docs/{docId}/attachments/store
- Read
List external attachment stores
GET /docs/{docId}/attachments/stores
- Read
Get attachment transfer status
GET /docs/{docId}/attachments/transferStatus
- Write
Upload attachments to a doc
POST /docs/{docId}/attachments
- Write
Upload missing attachments
Restores attachments which are missing from external storage.
- Write
Set external store
POST /docs/{docId}/attachments/store
- Write
Start transferring attachments
POST /docs/{docId}/attachments/transferAll
- Write
Update attachment usage tracking
Recalculate which attachments are in use by scanning the document. This is mostly used for testing and maintenance.
- Write
Verify attachment file integrity
Verify that attachment records match the actual stored files. This is a maintenance endpoint to check for data consistency. Only document owners can call this endpoint.
- Destructive
Delete unused attachments from the document
When an uploaded attachment is no longer used in a Grist document, it's retained for a period of time in case it's needed again (e.g. to facilitate an "undo"). This removes all of these retained attachments, reducing the amount of storage used.
Records
- Read
Fetch records from a table
GET /docs/{docId}/tables/{tableId}/records
- Write
Add records to a table
POST /docs/{docId}/tables/{tableId}/records
- Write
Modify records of a table
PATCH /docs/{docId}/tables/{tableId}/records
- Destructive
Add or update records of a table
PUT /docs/{docId}/tables/{tableId}/records
- Destructive
Delete records of a table
POST /docs/{docId}/tables/{tableId}/records/delete
Tables
- Read
List tables in a document
GET /docs/{docId}/tables
- Write
Add tables to a document
POST /docs/{docId}/tables
- Write
Modify tables of a document
Modify metadata for existing tables. This endpoint is primarily useful for: - Renaming tables (via the tableId field) - Setting on-demand loading (via the onDemand field)
Columns
- Read
List columns in a table
GET /docs/{docId}/tables/{tableId}/columns
- Write
Add columns to a table
POST /docs/{docId}/tables/{tableId}/columns
- Write
Modify columns of a table
PATCH /docs/{docId}/tables/{tableId}/columns
- Destructive
Add or update columns of a table
PUT /docs/{docId}/tables/{tableId}/columns
- Destructive
Delete a column of a table
DELETE /docs/{docId}/tables/{tableId}/columns/{colId}
Forms
- Read
Get form view data
Get the form configuration for a specific view section. Forms are a special view type that allows external users to submit data.
Webhooks
- Read
Webhooks associated with a document
Returns all webhooks configured for this document, including their settings and delivery statistics.
- Write
Create new webhooks for a document
Creates one or more webhooks that will POST to specified URLs when data in the document changes. Returns the IDs of the created webhooks.
- Write
Modify a webhook
Update the configuration of an existing webhook, such as its URL, enabled state, or event types.
- Destructive
Remove a webhook
Permanently delete a webhook. Any pending deliveries in the queue for this webhook will also be removed.
- Destructive
Empty a document's queue of undelivered payloads
Clear all pending webhook deliveries for this document. Use this if the queue has built up due to unreachable endpoints.
- Destructive
Clear queue for a specific webhook
Clear the queue of pending payloads for a specific webhook. Only document owners can call this endpoint.
Sql
- Read
Run an SQL query against a document
Execute a read-only SQL SELECT query against the document's SQLite database. This is a simplified endpoint for basic queries. For queries with parameters or custom timeouts, use the POST endpoint instead.
- Write
Run an SQL query against a document, with options or parameters
Execute a read-only SQL SELECT query with support for parameterized queries and custom timeouts. All Grist documents are SQLite databases, and queries are executed directly against SQLite with security restrictions.
Profile
- Read
Get current user's profile
Returns the profile information of the currently authenticated user.
- Read
Get user's API key
Returns the current user's API key if one exists.
- Write
Update user's name
Update the display name for the current user.
- Write
Update user's locale
Update the locale preference for the current user.
- Write
Create or regenerate API key
Create a new API key or regenerate an existing one.
- Destructive
Delete user's API key
Delete the current user's API key.
Session
- Read
Get active session information
Returns information about the active user and organization for the current session.
- Read
Get all session users and organizations
Returns all user profiles logged into the current session and all organizations they can access.
- Write
Set active user for organization
Switch which user account is active for a given organization. Useful when a user has multiple accounts logged in.
Users
- Write
Disable a user
A disabled user can not log in and loses access to all pages, including public ones, as well as API access. The operation is non-destructive. Disabled users can be re-enabled. Only admin accounts can disable a user.
- Write
Enable a user
If a user has been disabled, this will restore their access, including API access. Only admin accounts can enable a user.
- Destructive
Delete a user from Grist
This action also deletes the user's personal organisation and all the workspaces and documents it contains. Currently, only the users themselves are allowed to delete their own accounts. ⚠️ This action cannot be undone, please be cautious when using this endpoint ⚠️
Service accounts
- Read
Get all your service accounts
This lists all your service accounts with their details.
- Read
Get a service account's details
This reports the details of a service account.
- Write
Create a service account
This creates a new service account with a new API key.
- Write
Modify a service account
This updates a service account's label, description or expiration date.
- Write
Generate a new service account's api key
This renews an api key of a given service account. Useful especially to change the API key when it has been leaked.
- Destructive
Delete a service account
This deletes a given service account.
- Destructive
Delete a service account's api key
Deletes the API key for a service account. The service account will no longer be able to authenticate until a new key is generated.
No operations match.
See How connections work for access and permissions, or browse all integrations.